/*
 * MemoryZone0.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "DSP28335/MemoryZone.h"
#include <stdint.h>


#ifndef SYSCTRL_MEMORYZONE0_H_
#define SYSCTRL_MEMORYZONE0_H_




struct ZONE0_Bank_H
{
    ZONE_REGISTER_16 h0;
    ZONE_REGISTER_16 h1;
    ZONE_REGISTER_16 h2;
    ZONE_REGISTER_16 h3;
    ZONE_REGISTER_16 h4;
    ZONE_REGISTER_16 h5;
    ZONE_REGISTER_16 h6;
    ZONE_REGISTER_16 h7;
    ZONE_REGISTER_16 h8;
    ZONE_REGISTER_16 h9;
    ZONE_REGISTER_16 hA;
    ZONE_REGISTER_16 hB;
    ZONE_REGISTER_16 hC;
    ZONE_REGISTER_16 hD;
    ZONE_REGISTER_16 hE;
    ZONE_REGISTER_16 hF;
};//

struct ZONE0_Bank_HH
{
    ZONE0_Bank_H hh0;
    ZONE0_Bank_H hh1;
    ZONE0_Bank_H hh2;
    ZONE0_Bank_H hh3;
    ZONE0_Bank_H hh4;
    ZONE0_Bank_H hh5;
    ZONE0_Bank_H hh6;
    ZONE0_Bank_H hh7;
    ZONE0_Bank_H hh8;
    ZONE0_Bank_H hh9;
    ZONE0_Bank_H hhA;
    ZONE0_Bank_H hhB;
    ZONE0_Bank_H hhC;
    ZONE0_Bank_H hhD;
    ZONE0_Bank_H hhE;
    ZONE0_Bank_H hhF;
};//

struct ZONE0_Bank_HHH
{
    ZONE0_Bank_HH hhh0;
    ZONE0_Bank_HH hhh1;
    ZONE0_Bank_HH hhh2;
    ZONE0_Bank_HH hhh3;
    ZONE0_Bank_HH hhh4;
    ZONE0_Bank_HH hhh5;
    ZONE0_Bank_HH hhh6;
    ZONE0_Bank_HH hhh7;
    ZONE0_Bank_HH hhh8;
    ZONE0_Bank_HH hhh9;
    ZONE0_Bank_HH hhhA;
    ZONE0_Bank_HH hhhB;
    ZONE0_Bank_HH hhhC;
    ZONE0_Bank_HH hhhD;
    ZONE0_Bank_HH hhhE;
    ZONE0_Bank_HH hhhF;
};//




struct DATA_ZONE0_STRUCTURE
{
    int16_t &cmpr_a;
    int16_t &cmpr_b;
    int16_t &cmpr_c;
    DATA_ZONE0_STRUCTURE(int16_t &cmpa, int16_t &cmpb, int16_t &cmpc):
        cmpr_a(cmpa),
        cmpr_b(cmpb),
        cmpr_c(cmpc)
    {}
};//

struct ADC_ACCESS_STRUCTURE
{
    int16_t *read_channel_a0;
    int16_t *read_channel_a1;
    int16_t *read_channel_b0;
    int16_t *read_channel_b1;
    int16_t *read_channel_c0;
    int16_t *read_channel_c1;
};//



#endif /* SYSCTRL_MEMORYZONE0_H_ */
