/*
 * IIIPeriphery.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "PERIPHERY/Periphery.h"


#ifndef PERIPHERY_IIIPERIPHERY_H_
#define PERIPHERY_IIIPERIPHERY_H_

namespace PERIPHERY
{


struct IIIPeripherySetup: public PeripherySetup
{
    PWMStructureSetup pwm_brd;
    IIIPeripherySetup():
        PeripherySetup(),
        pwm_brd()
    {}
};//

//struct IIIPeripheryConfiguration
//{

    //PWMABCInterfaceConfiguration pwm_brd;
//    IIIPeripheryConfiguration()
//        pwm_brd()
//    {}
//};//PeripheryConfiguration


class IIIPeriphery: public Periphery
{
public:
    PERIPHERY::PWMABCInterace   pwm_brd;
public:
    IIIPeriphery();
    void setup(uint16_t *memzone);
    void setup(uint16_t *memzone, const IIIPeripherySetup& setup);
    //void configure(IIIPeripheryConfiguration& config);
    void get_hard_code_setup(IIIPeripherySetup& hsetup);
};

} /* namespace PERIPHERY */

#endif /* PERIPHERY_IIIPERIPHERY_H_ */
